﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridHierarchicalHideRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DrawFilter = new MyDraw1();
        }

        private void ultraGrid1_DoubleClick(object sender, EventArgs e)
        {
           // if (ultraGrid1.ActiveRow != null) ultraGrid1.ActiveRow.Hidden = true;
        }

        private void ultraColorPicker1_ColorChanged(object sender, EventArgs e)
        {
            MyDraw1.AltColor = ultraColorPicker1.Color;
            ultraGrid1.Invalidate();
        }
    }

    public class MyDraw1 : IUIElementDrawFilter
    {
        public static Color AltColor;
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            EditorWithTextUIElement slot = drawParams.Element as EditorWithTextUIElement;
            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null && ((UltraGridRow)slot.Parent.Parent.SelectableItem).IsAlternate) 
            {
                drawParams.AppearanceData.BackColor = AltColor;
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            EditorWithTextUIElement slot = drawParams.Element as EditorWithTextUIElement;
            if (slot != null )
                return DrawPhase.BeforeDrawBackColor;
            else
                return DrawPhase.None;
        }
    }
}
